## ecflow 5.9.2

=== CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#       -DCMAKE_INSTALL_PREFIX=/path/to/install
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_CXX_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
##############################################################################

# need 3.12.0 as this has findBoost fix for the latest boost version 1.67
cmake_minimum_required( VERSION 3.12.0 FATAL_ERROR )

# ===========================================================================
# Change the default if NO CMAKE_BUILD_TYPE specified
if (NOT DEFINED CMAKE_BUILD_TYPE)
   set(CMAKE_BUILD_TYPE Release CACHE STRING "Build Configuration type" FORCE)
endif()

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild ) # Before project()  

# this will generate variables, see ACore/ecflow_version.h.in
project( ecflow LANGUAGES CXX VERSION 5.9.2 )


include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 1.6 )
set (CMAKE_CXX_STANDARD 17)

###############################################################################
# local project

ecbuild_declare_project()

ecbuild_info( "CMAKE_MODULE_PATH        : ${CMAKE_MODULE_PATH}")
ecbuild_info( "CMAKE_INSTALL_PREFIX     : ${CMAKE_INSTALL_PREFIX}" )
ecbuild_info( "ecflow_BINARY_DIR        : ${ecflow_BINARY_DIR}" )
ecbuild_info( "ecflow_SOURCE_DIR        : ${ecflow_SOURCE_DIR}" )


# =========================================================================================
# Options , be aware of caching, when modifying on the command line. 
# Ideally start fresh or remove cache CmakeCache.txt in build dir
# =========================================================================================
option( ENABLE_SERVER              "Build the server, can be switched off if just building UI" ON  )
option( ENABLE_PYTHON              "enable python interface"         ON  )
option( ENABLE_UI                  "Build ecFlowUI"                  ON  ) 
option( ENABLE_STATIC_BOOST_LIBS   "Link with boost libs statically" ON  )
option( ENABLE_ALL_TESTS           "This includes performance/migration/regression tests" OFF )
option( ENABLE_UI_BACKTRACE        "Print a UI debug backtrace"         OFF ) 
option( ENABLE_UI_USAGE_LOG        "Enable UI usage logging"            OFF )
option( ENABLE_SSL                 "Enable SSL encrypted communication" ON )
option( ENABLE_PYTHON_PTR_REGISTER "Some compilers/boost versions do not register shared ptr automatically" OFF  )
option( ENABLE_PYTHON_UNDEF_LOOKUP "Some boost/python versions are too closely linked" OFF  )

# =========================================================================================
# Qt for ecFlowUI. 
# Algorithm: we test for Qt6 - if it's there, then use it; otherwise look for Qt5.
#            if we don't find that, then we cannot build ecFlowUI.
# =========================================================================================
if(ENABLE_UI)

    ecbuild_info("")
    ecbuild_info("------------------------------ Qt start ---------------------------")
    ecbuild_info("ecFlowUI is enabled - searching for Qt6/Qt5")
    ecbuild_info("To use a self-built Qt installation, try setting CMAKE_PREFIX_PATH")

    find_package(Qt6Widgets)
    if( Qt6Widgets_FOUND )
        find_package(Qt6Core5Compat  REQUIRED)
        find_package(Qt6Gui          REQUIRED)
        find_package(Qt6Network      REQUIRED)
        find_package(Qt6Svg          REQUIRED)
        find_package(Qt6Charts)

        ecbuild_debug("Qt6 version ${Qt6Widgets_VERSION_STRING} was found")
        set(ECFLOW_QT_INCLUDE_DIR ${Qt6Core5Compat_INCLUDE_DIRS} ${Qt6Widgets_INCLUDE_DIRS} ${Qt6Gui_INCLUDE_DIRS} ${Qt6Network_INCLUDE_DIRS} ${Qt6Svg_INCLUDE_DIRS})
        set(ECFLOW_QT_LIBRARIES  ${Qt6Core5Compat_LIBRARIES} ${Qt6Widgets_LIBRARIES}    ${Qt6Gui_LIBRARIES}   ${Qt6Network_LIBRARIES} ${Qt6Svg_LIBRARIES})
        set(ECFLOW_QT6 1)
        add_definitions(-DECFLOW_QT6)

        if(Qt6Charts_FOUND)
            ecbuild_info("Qt6Charts was found - the server log viewer will be built")
            list(APPEND ECFLOW_QT_INCLUDE_DIR ${Qt6Charts_INCLUDE_DIRS})
            list(APPEND ECFLOW_QT_LIBRARIES  ${Qt6Charts_LIBRARIES})
            set(ECFLOW_LOGVIEW 1)
            add_definitions(-DECFLOW_LOGVIEW)
        else()
            ecbuild_info("Qt6Charts was not found - the server log viewer will not be built")
        endif()
    else()
        find_package(Qt5Widgets)
        if (Qt5Widgets_FOUND)
            find_package(Qt5Gui          REQUIRED)
            find_package(Qt5Network      REQUIRED)
            find_package(Qt5Svg          REQUIRED)
            find_package(Qt5Charts)

            ecbuild_info("Qt5 version ${Qt5Widgets_VERSION_STRING} was found")
            set(ECFLOW_QT_INCLUDE_DIR ${Qt5Widgets_INCLUDE_DIRS} ${Qt5Gui_INCLUDE_DIRS} ${Qt5Network_INCLUDE_DIRS} ${Qt5Svg_INCLUDE_DIRS})
            set(ECFLOW_QT_LIBRARIES   ${Qt5Widgets_LIBRARIES}    ${Qt5Gui_LIBRARIES}   ${Qt5Network_LIBRARIES} ${Qt5Svg_LIBRARIES})
            set(ECFLOW_QT5 1)
            add_definitions(-DECFLOW_QT5)

            if(Qt5Charts_FOUND)
                ecbuild_info("Qt5Charts was found - the server log viewer will be built")
                list(APPEND ECFLOW_QT_INCLUDE_DIR ${Qt5Charts_INCLUDE_DIRS})
                list(APPEND ECFLOW_QT_LIBRARIES  ${Qt5Charts_LIBRARIES})
                set(ECFLOW_LOGVIEW 1)
                add_definitions(-DECFLOW_LOGVIEW)
            else()
                ecbuild_info("Qt5Charts was not found - the server log viewer will not be built")
            endif()
        else()
            ecbuild_critical("Qt5 Widgets, Network and Gui not found - these are required for ecFlowUI; or use -DENABLE_UI=OFF")
        endif()
    endif()

    set(ECFLOW_QT 1)
    add_definitions(-DQT_NO_KEYWORDS) # We need to disable keywords because there is a problem in using Qt and boost together.
    ecbuild_info("------------------------------ Qt end----------------------------")
    ecbuild_info("")

endif()


# sanity check - cannot set ENABLE_UI_BACKTRACE if UI is OFF
if(ENABLE_UI_BACKTRACE AND (NOT ENABLE_UI))
	ecbuild_warn("Cannot ENABLE_UI_BACKTRACE if UI is not enabled")
    set(ENABLE_UI_BACKTRACE OFF)
endif()

# sanity check - cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI and ENABLE_UI_BACKTRACE are OFF
if(UI_BACKTRACE_EMAIL_ADDRESS_FILE AND (NOT ENABLE_UI))
	ecbuild_warn("Cannot set UI_BACKTRACE_EMAIL_ADDRESS_FILE if UI is not enabled")
    set(UI_BACKTRACE_EMAIL_ADDRESS_FILE)
endif()

# sanity check - cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is OFF
if(UI_LOG_FILE AND (NOT ENABLE_UI_USAGE_LOG))
	ecbuild_warn("Cannot set UI_LOG_FILE if ENABLE_UI_USAGE_LOG is not enabled")
	set(UI_LOG_FILE)
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_FILE
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_FILE))
	ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_FILE must also be set")
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_FILE
if(ENABLE_UI_USAGE_LOG AND (NOT LOGUI_LOG_FILE))
    ecbuild_error("If ENABLE_UI_USAGE_LOG is set, LOGUI_LOG_FILE must also be set")
endif()

# sanity check - if ENABLE_UI_USAGE_LOG is ON, we must also have UI_LOG_SITE_TAG
if(ENABLE_UI_USAGE_LOG AND (NOT UI_LOG_SITE_TAG))
	ecbuild_error("If ENABLE_UI_USAGE_LOG is set, UI_LOG_SITE_TAG must also be set")
endif()

# sanity check - cannot set UI_SYSTEM_SERVERS_LIST if UI IS OFF
if(UI_SYSTEM_SERVERS_LIST AND (NOT ENABLE_UI))
        ecbuild_warn("Cannot set UI_SYSTEM_SERVERS_LIST if UI is not enabled")
    set(UI_SYSTEM_SERVERS_LIST)
endif()

ecbuild_info( "ENABLE_SERVER              : ${ENABLE_SERVER}" )
ecbuild_info( "ENABLE_PYTHON              : ${ENABLE_PYTHON}" )
ecbuild_info( "ENABLE_PYTHON_PTR_REGISTER : ${ENABLE_PYTHON_PTR_REGISTER}" )
ecbuild_info( "ENABLE_PYTHON_UNDEF_LOOKUP : ${ENABLE_PYTHON_UNDEF_LOOKUP}" )
ecbuild_info( "ENABLE_UI                  : ${ENABLE_UI}" )
ecbuild_info( "ENABLE_TESTS               : ${ENABLE_TESTS} *if* disabled no need for boost test libs" )
ecbuild_info( "ENABLE_ALL_TESTS           : ${ENABLE_ALL_TESTS}" )
ecbuild_info( "ENABLE_STATIC_BOOST_LIBS   : ${ENABLE_STATIC_BOOST_LIBS}" )
ecbuild_info( "ENABLE_SSL                 : ${ENABLE_SSL} *if* openssl libraries available" )


if (ENABLE_UI)
	ecbuild_info( "ENABLE_UI_BACKTRACE        : ${ENABLE_UI_BACKTRACE}" )
	if(UI_BACKTRACE_EMAIL_ADDRESS_FILE)
		ecbuild_info( "UI_BACKTRACE_EMAIL_ADDRESS_FILE : ${UI_BACKTRACE_EMAIL_ADDRESS_FILE}" )
	endif()

        if(LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE)
            ecbuild_info( "LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE : ${LOGUI_BACKTRACE_EMAIL_ADDRESS_FILE}" )
        endif()

        if(UI_SYSTEM_SERVERS_LIST)
                ecbuild_info( "UI_SYSTEM_SERVERS_LIST : ${UI_SYSTEM_SERVERS_LIST}" )
        endif()

	ecbuild_info( "ENABLE_UI_USAGE_LOG        : ${ENABLE_UI_USAGE_LOG}" )
	if(ENABLE_UI_USAGE_LOG)
            ecbuild_info( "UI_LOG_FILE                : ${UI_LOG_FILE}" )
            ecbuild_info( "LOGUI_LOG_FILE             : ${LOGUI_LOG_FILE}" )
            ecbuild_info( "UI_LOG_SITE_TAG            : ${UI_LOG_SITE_TAG}" )
	endif()
endif()
ecbuild_info("")


# =========================================================================================
# cereal is embedded
# =========================================================================================
include_directories( ${CMAKE_SOURCE_DIR}/cereal/include )
 

message( STATUS "====================================================================================================================" )
message( STATUS "BOOST" )
# this can help in some situations:
set (_CMAKE_PREFIX_PATH_BACKUP ${CMAKE_PREFIX_PATH}) # make a backup of CMAKE_PREFIX_PATH
foreach(BOOST_PATH_TO_SEARCH ${BOOST_PATH} ${BOOST_ROOT} $ENV{BOOST_ROOT})
    ecbuild_debug("adding: ${BOOST_PATH_TO_SEARCH} to CMAKE_PREFIX_PATH")
    list(APPEND CMAKE_PREFIX_PATH ${BOOST_PATH_TO_SEARCH})
    list(REMOVE_DUPLICATES CMAKE_PREFIX_PATH)
endforeach()

# Ecflow test require statics libs for boost < 1.59, otherwise get double free error.
# To use static boost python ensure that Boost_USE_STATIC_LIBS is set on.
# See: http://www.cmake.org/cmake/help/v3.0/module/FindBoost.html
if ( ENABLE_STATIC_BOOST_LIBS )
    set(Boost_USE_STATIC_LIBS ON)
    ecbuild_info( "Using STATIC boost libraries : ${BOOST_TEST_DYN_LINK}" )
else()
    set(BOOST_TEST_DYN_LINK "BOOST_TEST_DYN_LINK")
    ecbuild_info( "Using SHARED boost libraries setting : ${BOOST_TEST_DYN_LINK}" )
endif()

# By default cmake assume boost was built with cmake. Hence looks for package config file BoostConfig.cmake/boost-config.cmake
# This seems to mess up the search for boost python libs.
# if Boost_NO_BOOST_CMAKE is not set, we seem to mess up in finding right python libs(python3 and python2), 
# for boost 1.71 and cmake 3.15 or greater
set(Boost_NO_BOOST_CMAKE ON) 

set(Boost_USE_MULTITHREADED  ON)
set(Boost_NO_SYSTEM_PATHS    ON)
set(Boost_DETAILED_FAILURE_MSG ON)
set(Boost_ARCHITECTURE       "-x64") # from boost 1.69 layout=tagged adds libboost_system-mt-x64.a, https://gitlab.kitware.com/cmake/cmake/issues/18908
#set(Boost_DEBUG                ON) # Set to ON to enable debug output from FindBoost

set(ECFLOW_BOOST_VERSION "1.66.0")

# need upfront to get a hold of Boost_VERSION_STRING
find_package( Boost ${ECFLOW_BOOST_VERSION} ) 

# HAVE_TESTS is defined if ecbuild ENABLE_TESTS is set, (by default this is set)
if(HAVE_TESTS)
	list(APPEND _boost_testlibs unit_test_framework test_exec_monitor )
endif()

# Need timer for boost::time::cpu_timer this needs boost:chrono, which need librt These are used in the test only

=== Doc/CMakeLists.txt ===
 
 # sphinx
 configure_file( ${CMAKE_SOURCE_DIR}/Doc/online/conf.py.in ${CMAKE_SOURCE_DIR}/Doc/online/conf.py )

=== Http/CMakeLists.txt ===
 # =======================================================
 # LIB
 # to list all sources to build use:
 #    cd $WK/Client
 #    find src -name \*.cpp --print
 # =======================================================
 
 # Excludes src/HttpServerMain.cpp
list( APPEND srcs
   src/HttpServer.cpp
   src/ApiV1.cpp
   src/ApiV1Impl.cpp
   src/BasicAuth.cpp
   src/TypeToJson.cpp
   src/TokenStorage.cpp
)
ecbuild_add_library( TARGET libhttp
                     NOINSTALL
                     TYPE     STATIC
                     SOURCES  ${srcs}
                )

target_link_libraries(libhttp base node nodeattr core pthread)
target_include_directories(libhttp PUBLIC src
                                             ../ACore/src
                                             ../ANattr/src
                                             ../ANode/src
                                             ../Base/src
                                             ../Base/src/cts
                                             ../Base/src/stc
					     ../Client/src
                                             ../cpp-httplib
                                             ../json
)



# ========================================================================
# EXE ecflow_http, if OpenSSL not enabled ${OPENSSL_LIBRARIES}, is empty

ecbuild_add_executable( TARGET   ecflow_http
                        SOURCES  src/HttpMain.cpp
                        LIBS     libhttp libclient ${OPENSSL_LIBRARIES}
                        INCLUDES ${Boost_INCLUDE_DIRS} ../cpp-httplib
                      )

# Override default behaviour that add RPATHS during install
# The only thing that seem to work is set INSTALL_RPATH to ""
# Using SKIP_BUILD_RPATH,BUILD_WITH_INSTALL_RPATH,INSTALL_RPATH_USE_LINK_PATH
# had no effect
#          
SET_TARGET_PROPERTIES(ecflow_http PROPERTIES 
                                    INSTALL_RPATH ""
                     )
                         
# use, i.e. don't skip the full RPATH for the build tree
#SET(CMAKE_SKIP_BUILD_RPATH  FALSE)

# when building, don't use the install RPATH already
# (but later on when installing)
#SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) 

# the RPATH to be used when installing
#SET(CMAKE_INSTALL_RPATH "")

# don't add the automatically determined parts of the RPATH
# which point to directories outside the build tree to the install RPATH
#SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH FALSE)

if (ENABLE_HTTP AND ENABLE_SERVER)

  list(APPEND test_srcs
       test/TestApiV1.cpp
  )

  ecbuild_add_test( TARGET       s_http
                    SOURCES      ${test_srcs}
                    LIBS         libhttp libclient libserver ${OPENSSL_LIBRARIES} 
                                 ${Boost_UNIT_TEST_FRAMEWORK_LIBRARY} ${Boost_TEST_EXEC_MONITOR_LIBRARY}
                                 ${Boost_TIMER_LIBRARY} ${Boost_CHRONO_LIBRARY} ${LIBRT}
                    INCLUDES     src
                                 ../ANode/test
                                 ../Base/test
                                 ../Server/src
                                 ${Boost_INCLUDE_DIRS}
                    DEFINITIONS  ${BOOST_TEST_DYN_LINK}
                    TEST_DEPENDS u_base s_client
  )

endif()


# ===================================================================
# install
# ===================================================================
install (TARGETS ecflow_http DESTINATION bin)

=== Pyext/CMakeLists.txt ===
### ecflow python bindings
# NOTES:
# 1/ Building multiple python3 versions not supported, since find_python(..) caches variables, Hack: clear cached variable.
#    https://gitlab.kitware.com/cmake/cmake/issues/19820
#
# 2/
# To see the python link line: Do python-config  --ldflags, i.e
#   > /usr/local/apps/python/2.7.8-01/bin/python-config  --ldflags
#   > -lpthread -ldl -lutil -lm -lpython2.7 -Xlinker -export-dynamic
#
# However on cct we get:
#   > /usr/local/apps/python/2.7.5-01/bin/python-config --ldflags
#   > -L/usr/local/apps/python/2.7.5-01/lib/python2.7/config -lpthread -ldl -lutil -lm -lpython2.7 -Xlinker -export-dynamic
#
# cct is correct as it has the "-L" but on other machines we rely on /usr/lib/libpython2.7.so.1.0 being there!
# lxop-test does not have /usr/lib/libpython2.7.so.1.0 so ecbuild fails
#
# For problems with the python build, please look in <build-dir>/ecbuild.log, typically non developmental python
# installs may not include python libs or includes
# For ubuntoo to install we need:
#    sudo apt-get install libpython-dev
#

# =============================================================================
# Configure __init__.py to add __version__
# =============================================================================
set(INIT_PY_IN  "${CMAKE_CURRENT_SOURCE_DIR}/ecflow/__init__.py.in")
set(INIT_PY_OUT "${CMAKE_CURRENT_SOURCE_DIR}/ecflow/__init__.py")
configure_file(${INIT_PY_IN} ${INIT_PY_OUT} )

# =============================================================================
# Configure setup.py. Note used locally. Uses existing libraries
# =============================================================================
set(SETUP_PY_IN  "${CMAKE_CURRENT_SOURCE_DIR}/setup.py.in")
set(SETUP_PY_OUT "${CMAKE_CURRENT_SOURCE_DIR}/setup.py")
configure_file(${SETUP_PY_IN} ${SETUP_PY_OUT} )


# ==============================================================================
# local includes
# ==============================================================================
include_directories(  
                     ../ACore/src 
                     ../ANattr/src
                     ../ANode/src
                     ../Base/src
                     ../Base/src/cts
                     ../Base/src/stc
                     ../Client/src
                     ../CSim/src
                    )

message( STATUS "====================================================================================================================" )
message( STATUS "PYTHON2" )
message( STATUS "====================================================================================================================" )
if(${CMAKE_VERSION} VERSION_LESS "3.12.0") 
	# We only support python2 extension for cmake less 3.12.0
	# cmake 3.12.0 or greater allows multiple boost python libs & hence multiple extensions to be built
	# Using -DPYTHON_EXECUTABLE=/usr/local/apps/python3/3.6.5-01/bin/python3 is not suffcient as the wrong(python2) libs are found
	ecbuild_find_python( VERSION 2.6 REQUIRED )  
	message( STATUS "  PYTHON_FOUND                      : ${PYTHON_FOUND}" )
    message( STATUS "  PYTHONINTERP_FOUND                : ${PYTHONINTERP_FOUND}" )
    message( STATUS "  PYTHONLIBS_FOUND                  : ${PYTHONLIBS_FOUND}" )
    message( STATUS "  PYTHON_VERSION_STRING             : ${PYTHON_VERSION_STRING}" )
    message( STATUS "  PYTHON_VERSION_MAJOR              : ${PYTHON_VERSION_MAJOR}" )
    message( STATUS "  PYTHON_VERSION_MINOR              : ${PYTHON_VERSION_MINOR}" )
    message( STATUS "  PYTHON_VERSION_PATCH              : ${PYTHON_VERSION_PATCH}" )
    message( STATUS "  PYTHON_CONFIG_EXECUTABLE          : ${PYTHON_CONFIG_EXECUTABLE}" )
    message( STATUS "  PYTHON_EXECUTABLE                 : ${PYTHON_EXECUTABLE}" )
    message( STATUS "  PYTHON_INCLUDE_DIRS               : ${PYTHON_INCLUDE_DIRS}" )
    message( STATUS "  PYTHON_LIBRARIES                  : ${PYTHON_LIBRARIES}" )
	if (${PYTHON_VERSION_MAJOR} EQUAL 3)
		ecbuild_error("Need cmake version >= 3.12.0 to build ecflow python3 extension, current cmake version is ${CMAKE_VERSION}")
	endif()

	find_package( Boost ${ECFLOW_BOOST_VERSION} REQUIRED COMPONENTS python )
	add_subdirectory( python2 )
else()
	# ======================================================================================
	# Attempt to build both python2 *AND/OR* python3 ecflow extension, depending on what is found
	# this assumes cmake 3.12.0 min, which added support for boost python2 and python3
	# * NOTICE* that we do *NOT* use REQUIRED when searching for boost python libs
	# ======================================================================================
	find_package(Python2 COMPONENTS Interpreter Development)
	if (Python2_FOUND)
		message( STATUS "  Python2_Interpreter_FOUND         : ${Python2_Interpreter_FOUND}" )
		message( STATUS "  Python2_EXECUTABLE                : ${Python2_EXECUTABLE}" )
		message( STATUS "  Python2_STDLIB                    : ${Python2_STDLIB}    Standard platform independent installation directory" )
		message( STATUS "  Python2_STDARCH                   : ${Python2_STDARCH}   Standard platform dependent installation directory." )
		message( STATUS "  Python2_Development_FOUND         : ${Python2_Development_FOUND}" )
	    message( STATUS "  Python2_INCLUDE_DIRS              : ${Python2_INCLUDE_DIRS}" )
		message( STATUS "  Python2_LIBRARIES                 : ${Python2_LIBRARIES}" )
	    message( STATUS "  Python2_LIBRARY_DIRS              : ${Python2_LIBRARY_DIRS}" )
		message( STATUS "  Python2_VERSION                   : ${Python2_VERSION}" )
		message( STATUS "  Python2_VERSION_MAJOR             : ${Python2_VERSION_MAJOR}" )
		message( STATUS "  Python2_VERSION_MINOR             : ${Python2_VERSION_MINOR}" )
		message( STATUS "  Python2_VERSION_PATCH             : ${Python2_VERSION_PATCH}" )
	    # *****************************************************************************************
	    # Although we have found python2 it could be that *ONLY* python3 was module loaded
	    # Otherwise will build for python2 and test with python3 interpreter
	    # *****************************************************************************************
	    if ( Python2_LIBRARIES )             
	    	ecbuild_find_python( VERSION 2.6 REQUIRED ) # if not included iterpreter not found ?
	    	if ( ${PYTHON_VERSION_MAJOR} EQUAL 2)
		    	message( STATUS "  PYTHON_FOUND                      : ${PYTHON_FOUND}" )
		    	message( STATUS "  PYTHONINTERP_FOUND                : ${PYTHONINTERP_FOUND}" )
		   		message( STATUS "  PYTHONLIBS_FOUND                  : ${PYTHONLIBS_FOUND}" )
		    	message( STATUS "  PYTHON_VERSION_STRING             : ${PYTHON_VERSION_STRING}" )
		    	message( STATUS "  PYTHON_VERSION_MAJOR              : ${PYTHON_VERSION_MAJOR}" )
		    	message( STATUS "  PYTHON_VERSION_MINOR              : ${PYTHON_VERSION_MINOR}" )
		    	message( STATUS "  PYTHON_VERSION_PATCH              : ${PYTHON_VERSION_PATCH}" )
		    	message( STATUS "  PYTHON_CONFIG_EXECUTABLE          : ${PYTHON_CONFIG_EXECUTABLE}" )
		    	message( STATUS "  PYTHON_EXECUTABLE                 : ${PYTHON_EXECUTABLE}" )
		    	message( STATUS "  PYTHON_INCLUDE_DIRS               : ${PYTHON_INCLUDE_DIRS}" )
		    	message( STATUS "  PYTHON_LIBRARIES                  : ${PYTHON_LIBRARIES}" )

    			if ( Boost_MINOR_VERSION GREATER 66 )
    			    # cmake 3.15
    			    # see: https://gitlab.kitware.com/cmake/cmake/issues/19656
                    # INTERFACE_LIBRARY targets may only have whitelisted properties." 
           		    find_package( Boost ${ECFLOW_BOOST_VERSION} COMPONENTS python${Python2_VERSION_MAJOR}${Python2_VERSION_MINOR} )
			    else()
	   			    find_package( Boost ${ECFLOW_BOOST_VERSION} COMPONENTS python )
			    endif()

		        if (Boost_PYTHON_FOUND OR Boost_PYTHON${Python2_VERSION_MAJOR}${Python2_VERSION_MINOR}_FOUND) 
					set(ECF_PYTHON_FOUND "ECF_PYTHON_FOUND")
					add_subdirectory( python2 )
				else()
					message( STATUS "  Boost python2 libraries *NOT* found" )
				endif()
			endif()
		else()
		    message( STATUS "  Python2 libraries *NOT* found" )
		endif()
	endif()

	message( STATUS "====================================================================================================================" )
	message( STATUS "PYTHON3" )
	message( STATUS "====================================================================================================================" )
	# The python must include the Development packages. As the headers in these packages is used by boost python.
	find_package(Python3 COMPONENTS Interpreter Development)
	if (Python3_FOUND)
		message( STATUS "  Python3_Interpreter_FOUND         : ${Python3_Interpreter_FOUND}" )
		message( STATUS "  Python3_EXECUTABLE                : ${Python3_EXECUTABLE}" )
		message( STATUS "  Python3_STDLIB                    : ${Python3_STDLIB}    Standard platform independent installation directory" )
		message( STATUS "  Python3_STDARCH                   : ${Python3_STDARCH}   Standard platform dependent installation directory." )
		message( STATUS "  Python3_Development_FOUND         : ${Python3_Development_FOUND}" )
		message( STATUS "  Python3_INCLUDE_DIRS              : ${Python3_INCLUDE_DIRS}" )
		message( STATUS "  Python3_LIBRARIES                 : ${Python3_LIBRARIES}" )
		message( STATUS "  Python3_LIBRARY_DIRS              : ${Python3_LIBRARY_DIRS}" )
		message( STATUS "  Python3_VERSION                   : ${Python3_VERSION}" )
		message( STATUS "  Python3_VERSION_MAJOR             : ${Python3_VERSION_MAJOR}" )
		message( STATUS "  Python3_VERSION_MINOR             : ${Python3_VERSION_MINOR}" )
		message( STATUS "  Python3_VERSION_PATCH             : ${Python3_VERSION_PATCH}" )

	    if ( Boost_MINOR_VERSION GREATER 66 )
            # cmake 3.15
	        # see: https://gitlab.kitware.com/cmake/cmake/issues/19656
	        # INTERFACE_LIBRARY targets may only have whitelisted properties.  
	       	find_package( Boost ${ECFLOW_BOOST_VERSION} COMPONENTS python${Python3_VERSION_MAJOR}${Python3_VERSION_MINOR} )
		else()
	   		find_package( Boost ${ECFLOW_BOOST_VERSION} COMPONENTS python3 )
		endif()
		
	    if (Boost_PYTHON3_FOUND OR Boost_PYTHON${Python3_VERSION_MAJOR}${Python3_VERSION_MINOR}_FOUND)
	 	    if ( Python3_LIBRARIES )             
	    		ecbuild_find_python( VERSION ${Python3_VERSION} REQUIRED )
				set(ECF_PYTHON_FOUND "ECF_PYTHON_FOUND")
				add_subdirectory( python3 )
			else()
				message( STATUS "  python3 libraries *NOT* found" )
			endif()
		else()
			message( STATUS "  Boost python3 libraries *NOT* found" )
		endif()
	endif()
	
	if (NOT ECF_PYTHON_FOUND)
		ecbuild_error("ecflow python extension is enabled, but python2/python3 libraries or python boost libraries not found")
	endif()
endif()
message( STATUS "====================================================================================================================" )
message( STATUS "END PYTHON" )
message( STATUS "====================================================================================================================" )

=== share/CMakeLists.txt ===

add_subdirectory(ecflow/etc)
add_subdirectory(ecflow/etc/sounds)

=== Viewer/ecflowUI/scripts/CMakeLists.txt ===

# the list of files we want to install bin
set (files ecflow_ui)

# the list of files we want to install to share/ecflow/etc
set (files_share ecflow_ui_create_jira_issue.sh
    ecflow_ui_node_state_diag.sh ecflow_ui_transfer_file.sh ecflow_test_ui.sh)

# set variables which will be expanded in the startup script
if(ENABLE_UI_BACKTRACE)
    set(UI_BACKTRACE yes)
else()
    set(UI_BACKTRACE no)
endif()

if(NOT UI_BACKTRACE_EMAIL_ADDRESS_FILE)
    set(UI_BACKTRACE_EMAIL_ADDRESS_FILE "x")
endif()

if(NOT UI_LOG_FILE)
	set(UI_LOG_FILE "x")
endif()

if(NOT UI_LOG_SITE_TAG)
	set(UI_LOG_SITE_TAG "x")
endif()

# for each file, copy it into the build directory at build time
# and install it into the installation directory at install time (!)
foreach( f ${files} )
    configure_file(${f}.in ${CMAKE_BINARY_DIR}/bin/${f} @ONLY)


    # ensure file is installed at install time
    install( FILES ${CMAKE_BINARY_DIR}/bin/${f}
             DESTINATION bin
             PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)

endforeach()


# for each file, copy it into the build directory at build time
# and install it into the installation directory at install time (!)
foreach( f ${files_share} )
    configure_file(${f}.in ${CMAKE_BINARY_DIR}/share/ecflow/etc/${f} @ONLY)


    install( FILES ${CMAKE_BINARY_DIR}/share/ecflow/etc/${f}
             DESTINATION share/ecflow/etc
             PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)
endforeach()

=== Viewer/ecflowUI/src/CMakeLists.txt ===

set(viewer_srcs   
    ViewerMain.cpp
    AboutDialog.cpp
    AbstractNodeModel.cpp
    AbstractNodeView.cpp
    AbstractSearchLine.cpp
    AbstractTextEditSearchInterface.cpp
    ActionHandler.cpp
    AddLabelDialog.cpp
    AddModelColumnDialog.cpp
    Animation.cpp
    AstCollateVNodesVisitor.cpp
    AttributeEditor.cpp
    AttributeEditorFactory.cpp   
    CaseSensitiveButton.cpp
    ChangeNotify.cpp
    ChangeNotifyDialog.cpp
    ChangeNotifyEditor.cpp
    ChangeNotifyModel.cpp
    ChangeNotifyWidget.cpp
    ClockWidget.cpp
    CodeItemWidget.cpp
    ComboMulti.cpp
    CommandDesignerWidget.cpp
    CommandHandler.cpp
    CommandOutput.cpp
    CommandOutputDialog.cpp
    CommandOutputWidget.cpp
    CompactView.cpp
    ConfigListDelegate.cpp
    ConnectState.cpp
    CustomCommandDialog.cpp
    CustomCommandHandler.cpp
    CustomListWidget.cpp
    CustomTabWidget.cpp
    Dashboard.cpp
    DashboardDialog.cpp
    DashboardDock.cpp
    DashboardTitle.cpp
    DashboardWidget.cpp
    DiagData.cpp
    EditItemWidget.cpp
    EditProvider.cpp
    EditorInfoLabel.cpp
    EventEditor.cpp
    ExpandState.cpp
    ExpandStateNode.cpp
    FetchTask.cpp
    FlagSet.hpp
    FileFetchTask.cpp
    FileInfoLabel.cpp   
    FileWatcher.cpp
    FilterWidget.cpp
    FontMetrics.cpp
    GenFileProvider.cpp
    GotoLineDialog.cpp
    Highlighter.cpp
    HistoryItemWidget.cpp
    HtmlEdit.cpp
    HtmlItemWidget.cpp
    InfoPanel.cpp 
    InfoPanelItem.cpp   
    InfoPanelHandler.cpp
    InfoProvider.cpp
    InputEventLog.cpp
    JobItemWidget.cpp
    JobStatusItemWidget.cpp
    LabelEditor.cpp
    LimitEditor.cpp
    LineEdit.cpp  
    LogProvider.cpp     
    LogViewerCom.cpp
    MainWindow.cpp
    ManualItemWidget.cpp 
    MenuConfigDialog.cpp
    MenuHandler.cpp
    MessageItemWidget.cpp
    MeterEditor.cpp
    ModelColumn.cpp
    NodeExpression.cpp
    NodeFilterDialog.cpp    
    NodePanel.cpp
    NodePathWidget.cpp
    NodeQuery.cpp
    NodeQueryCombo.cpp
    NodeQueryEditor.cpp
    NodeQueryEngine.cpp
    NodeQueryHandler.cpp
    NodeQueryOption.cpp
    NodeQueryOptionEdit.cpp
    NodeQueryResult.cpp
    NodeQueryResultModel.cpp
    NodeQueryResultView.cpp
    NodeQueryViewDelegate.cpp
    NodeSearchWindow.cpp
    NodeSearchWidget.cpp
    NodeViewBase.cpp
    NodeViewDelegate.cpp
    NodeWidget.cpp
    OneLineTextEdit.cpp
    OutputBrowser.cpp
    OutputCache.cpp
    OutputClient.cpp
    OutputFetchInfo.cpp
    OutputFileClient.cpp
    OutputDirClient.cpp
    OutputModel.cpp
    OutputItemWidget.cpp
    OutputFileProvider.cpp
    OutputDirProvider.cpp
    OutputDirWidget.cpp
    OverviewItemWidget.cpp
    OverviewProvider.cpp
    PlainTextEdit.cpp
    PlainTextSearchLine.cpp
    PlainTextSearchInterface.cpp
    PropertyDialog.cpp
    PropertyEditor.cpp
    PropertyLine.cpp
    PropertyMapper.cpp
    RectMetrics.cpp
    RepeatEditor.cpp
    RichTextEdit.cpp
    RichTextSearchInterface.cpp
    RichTextSearchLine.cpp
    SaveSessionAsDialog.cpp
    ScriptItemWidget.cpp
    ServerComInfoWidget.cpp
    ServerComQueue.cpp
    ServerComThread.cpp
    ServerDefsAccess.cpp
    ServerHandler.cpp
    ServerFilter.cpp
    ServerItem.cpp
    ServerList.cpp
    ServerListDialog.cpp
    ServerListSyncWidget.cpp   
    ServerLoadItemWidget.cpp
    ServerSettingsItemWidget.cpp
    SessionDialog.cpp
    SessionRenameDialog.cpp
    SessionHandler.cpp
    ShellCommand.cpp
    ShortcutHelpDialog.cpp
    Sound.cpp
    Spline.cpp
    StandardView.cpp
    StringMatchCombo.cpp
    StringMatchMode.cpp
    SuiteItemWidget.cpp
    SuiteFilter.cpp
    SuiteFilterObserver.hpp
    SuiteModel.cpp
    TabWidget.cpp 
    TableFilterWidget.cpp
    TableNodeModel.cpp
    TableNodeSortModel.cpp
    TableNodeView.cpp
    TableNodeViewDelegate.cpp
    TableNodeWidget.cpp
    TextEditSearchLine.cpp
    TextFilterHandler.cpp
    TextFilterHandlerDialog.cpp
    TextFilterWidget.cpp   
    TimelineHeaderView.cpp
    TimelineInfoDailyView.cpp
    TimelineInfoDailyWidget.cpp
    TimelineInfoDelegate.cpp
    TimelineInfoWidget.cpp
    TimelineItemWidget.cpp
    TimelineData.cpp
    TimelineFileList.cpp
    TimelineModel.cpp
    TimelinePreLoadDialog.cpp
    TimelineView.cpp
    TimelineWidget.cpp
    TreeNodeModel.cpp
    TreeNodeView.cpp
    TreeNodeViewDelegate.cpp
    TreeNodeWidget.cpp
    TreeView.cpp
    TriggerEditor.cpp   
    TriggerItemWidget.cpp
    TriggerTextWidget.cpp    
    TriggerCollector.cpp
    TriggerGraphLayoutBuilder.cpp
    TriggerGraphModel.cpp
    TriggerGraphWidget.cpp
    TriggerGraphView.cpp
    TriggerTableModel.cpp
    TriggerTableView.cpp
    TriggerTableWidget.cpp
    TriggerViewDelegate.cpp
    TriggeredScanner.cpp    
    UiLogS.cpp
    UpdateTimer.cpp
    VAttribute.cpp
    VAttributeType.cpp
    VAutoArchiveAttr.cpp
    VAutoCancelAttr.cpp
    VAutoRestoreAttr.cpp
    VConfig.cpp
    VConfigLoader.cpp
    VDateAttr.cpp
    VDir.cpp
    VEventAttr.cpp
    VFilter.cpp
    VIcon.cpp
    VInfo.cpp
    VFile.cpp
    VFileInfo.cpp
    VFileTransfer.cpp
    VFileUncompress.cpp
    VItem.cpp
    VItemPathParser.cpp
    VLabelAttr.cpp
    VLateAttr.cpp
    VLimitAttr.cpp
    VLimiterAttr.cpp
    VMeterAttr.cpp
    VModelData.cpp
    VNode.cpp
    VNodeList.cpp
    VNodeMover.cpp
    VNodeStateDiag.cpp
    VNState.cpp
    VParam.cpp
    VProperty.cpp
    VQueueAttr.cpp
    VRepeatAttr.cpp
    VReply.cpp
    VReportMaker.cpp
    VServerSettings.cpp
    VSettings.cpp
    VSettingsLoader.cpp
    VSState.cpp
    VTask.cpp
    VTaskNode.cpp
    VTimeAttr.cpp
    VTree.cpp
    VTriggerAttr.cpp
    VGenVarAttr.cpp
    VUserVarAttr.cpp
    VariableEditor.cpp
    VariableModel.cpp
    VariableModelData.cpp
    VariableItemWidget.cpp
    VariableSearchLine.cpp
    VariableView.cpp
    ViewerUtil.cpp
    WhyItemWidget.cpp
    WidgetNameProvider.cpp
    WmWorkspaceHandler.cpp
    ZombieItemWidget.cpp
    ZombieModel.cpp
    TextPager/TextPagerCursor.cpp
    TextPager/TextPagerDocument.cpp
    TextPager/TextPagerEdit.cpp
    TextPager/TextPagerLayout_p.cpp
    TextPager/TextPagerSearchHighlighter.cpp
    TextPager/TextPagerSearchInterface.cpp
    TextPager/TextPagerSection.cpp
    TextPager/TextPagerWidget.cpp
    TextPager/syntaxhighlighter.cpp)

if(ECFLOW_QT)
    include_directories(${ECFLOW_QT_INCLUDE_DIR})
#else()
#    include(${QT_USE_FILE})
#    set(ECFLOW_QT_LIBRARIES ${QT_LIBRARIES})
endif()


set(viewer_moc_files AbstractNodeModel.hpp
    AbstractNodeView.hpp
    AbstractSearchLine.hpp
    ActionHandler.hpp
    AddLabelDialog.hpp
    AddModelColumnDialog.hpp
    Animation.hpp
    AttributeEditor.hpp
    CaseSensitiveButton.hpp
    ChangeNotifyDialog.hpp
    ChangeNotifyEditor.hpp
    ChangeNotifyModel.hpp
    ChangeNotifyWidget.hpp
    ClockWidget.hpp
    CodeItemWidget.hpp
    ComboMulti.hpp
    CommandDesignerWidget.hpp    
    CommandOutput.hpp
    CommandOutputDialog.hpp
    CommandOutputWidget.hpp
    CustomCommandDialog.hpp
    CustomListWidget.hpp
    Dashboard.hpp
    DashboardDialog.hpp
    DashboardDock.hpp
    DashboardTitle.hpp
    DashboardWidget.hpp
    EditItemWidget.hpp
    EventEditor.hpp
    FileFetchTask.hpp
    FileWatcher.hpp
    FilterWidget.hpp
    GotoLineDialog.hpp
    HistoryItemWidget.hpp              
    HtmlItemWidget.hpp
    InfoPanel.hpp
    InputEventLog.hpp
    JobStatusItemWidget.hpp
    LabelEditor.hpp
    LimitEditor.hpp
    LineEdit.hpp   
    LogProvider.hpp    
    MainWindow.hpp
    MenuConfigDialog.hpp
    MessageItemWidget.hpp
    MeterEditor.hpp
    ModelColumn.hpp
    NodeFilterDialog.hpp
    NodePanel.hpp
    NodePathWidget.hpp
    NodeQueryCombo.hpp           
    NodeQueryEditor.hpp
    NodeQueryOptionEdit.hpp
    NodeQueryEngine.hpp
    NodeQueryResult.hpp
    NodeQueryResultModel.hpp
    NodeQueryResultView.hpp
    NodeSearchWindow.hpp
    NodeSearchWidget.hpp
    NodeWidget.hpp
    OneLineTextEdit.hpp
    OutputBrowser.hpp
    OutputCache.hpp
    OutputClient.hpp
    OutputFetchInfo.hpp
    OutputFileClient.hpp
    OutputDirClient.hpp
    OutputItemWidget.hpp
    OutputDirProvider.hpp
    OutputDirWidget.hpp
    PlainTextEdit.hpp
    PropertyDialog.hpp             
    PropertyEditor.hpp
    PropertyLine.hpp
    SaveSessionAsDialog.hpp
    ShortcutHelpDialog.hpp
    RepeatEditor.hpp
    RichTextEdit.hpp
    ServerComInfoWidget.hpp
    ServerComQueue.hpp
    ServerComThread.hpp
    ServerHandler.hpp
    ServerListDialog.hpp
    ServerListSyncWidget.hpp
    ServerSettingsItemWidget.hpp
    SessionDialog.hpp
    SessionRenameDialog.hpp
    ShellCommand.hpp
    StringMatchCombo.hpp
    SuiteItemWidget.hpp
    SuiteModel.hpp
    TabWidget.hpp
    TableFilterWidget.hpp
    TableNodeModel.hpp 
    TableNodeSortModel.hpp
    TableNodeView.hpp 
    TableNodeViewDelegate.hpp
    TableNodeWidget.hpp             
    TextEditSearchLine.hpp
    TextFilterHandlerDialog.hpp
    TextFilterWidget.hpp
    TimelineData.hpp
    TimelineHeaderView.hpp
    TimelineInfoDailyView.hpp
    TimelineInfoDailyWidget.hpp
    TimelineInfoWidget.hpp
    TimelineModel.hpp
    TimelineView.hpp
    TimelineWidget.hpp
    TreeNodeModel.hpp
    TreeNodeView.hpp
    TreeNodeViewDelegate.hpp
    TreeNodeWidget.hpp    
    TriggerEditor.hpp
    TriggerGraphWidget.hpp
    TriggerGraphView.hpp
    TriggerItemWidget.hpp
    TriggerTableView.hpp
    TriggerTableWidget.hpp
    TriggeredScanner.hpp
    VariableEditor.hpp
    VariableItemWidget.hpp
    VariableModel.hpp
    VariableModelData.hpp
    VariableSearchLine.hpp
    VFileTransfer.hpp
    VFilter.hpp
    VModelData.hpp
    VNodeList.hpp
    WhyItemWidget.hpp
    ZombieItemWidget.hpp
    TextPager/TextCodecWrapper.hpp
    TextPager/TextPagerCursor_p.hpp
    TextPager/TextPagerDocument.hpp
    TextPager/TextPagerDocument_p.hpp
    TextPager/TextPagerEdit.hpp
    TextPager/TextPagerEdit_p.hpp
    TextPager/TextPagerSection_p.hpp
    TextPager/TextPagerWidget.hpp
    TextPager/syntaxhighlighter.hpp   
)

set(viewer_wrap_ui_files
    AboutDialog.ui
    AddLabelDialog.ui
    AddModelColumnDialog.ui
    AttributeEditorDialog.ui
    ChangeNotifyDialog.ui
    ChangeNotifyDialogWidget.ui
    ChangeNotifyEditor.ui
    CommandDesignerWidget.ui 
    CommandOutputDialog.ui
    CommandOutputWidget.ui
    CustomCommandDialog.ui
    CodeItemWidget.ui
    DashboardDialog.ui
    DashboardDockTitleWidget.ui
    EditItemWidget.ui
    EventEditorWidget.ui
    GotoLineDialog.ui
    HistoryItemWidget.ui
    HtmlItemWidget.ui
    InfoPanel.ui
    LabelEditorWidget.ui
    LimitEditorWidget.ui
    #LogLoadWidget.ui
    MainWindow.ui
    MessageItemWidget.ui
    MenuConfigDialog.ui
    MeterEditorWidget.ui
    NodeFilterDialog.ui
    NodeQueryEditor.ui
    NodeQuerySaveDialog.ui
    NodeSearchWindow.ui
    NodeSearchWidget.ui
    OutputFetchInfo.ui
    OutputItemWidget.ui
    OutputDirWidget.ui
    PropertyDialog.ui
    PropertyEditor.ui
    RepeatEditorWidget.ui
    SaveSessionAsDialog.ui
    SearchLineWidget.ui
    ServerAddDialog.ui
    ServerEditDialog.ui 
    ServerListDialog.ui
    ServerListSyncWidget.ui
    ServerLoadItemWidget.ui
    ServerSettingsItemWidget.ui
    SessionDialog.ui
    SessionRenameDialog.ui
    ShortcutHelpDialog.ui
    SuiteItemWidget.ui
    TableFilterWidget.ui
    TableNodeWidget.ui
    TextFilterAddDialog.ui
    TextFilterHandlerDialog.ui
    TextFilterWidget.ui
    TimelineInfoDailyWidget.ui
    TimelineInfoWidget.ui
    TimelinePreLoadDialog.ui
    TimelineWidget.ui
    TreeNodeWidget.ui
    TriggerEditorWidget.ui
    TriggerGraphWidget.ui
    TriggerItemWidget.ui
    TriggerTableWidget.ui
    VariableAddDialog.ui
    VariableEditorWidget.ui
    VariablePropDialog.ui
    VariableItemWidget.ui
    ZombieItemWidget.ui
)

if(ECFLOW_LOGVIEW)
    list(APPEND viewer_srcs LogLoadWidget.cpp LogLoadView.cpp)
    list(APPEND viewer_moc_files LogLoadWidget.hpp LogLoadView.hpp)
endif()

#set(wrap_ui_files
#    LogLoadWidget.ui
#    )

if(ECFLOW_LOGVIEW)
    list(APPEND viewer_wrap_ui_files
        LogLoadWidget.ui
        )
endif()


if(ECFLOW_QT6)

=== Viewer/libViewer/src/CMakeLists.txt ===
set(srcs
    DirectoryHandler.cpp
    IconProvider.cpp
    LocalSocketServer.cpp
    LogConsumer.hpp
    LogData.cpp    
    LogModel.cpp
    LogTruncator.cpp
    LogView.cpp
    MessageLabel.cpp
    Palette.cpp
    TextFormat.cpp
    UIDebug.cpp
    UiLog.cpp
    UserMessage.cpp   
    )

if(ECFLOW_LOGVIEW)
    list(APPEND srcs LogLoadData.cpp)
endif()

if(ECFLOW_QT)
    include_directories(${ECFLOW_QT_INCLUDE_DIR})
#else()
#    include(${QT_USE_FILE})
#    set(ECFLOW_QT_LIBRARIES ${QT_LIBRARIES})
endif()


set(moc_files
    LocalSocketServer.hpp
    LogModel.hpp
    LogTruncator.hpp
    LogView.hpp
    MessageLabel.hpp
)

if(ECFLOW_LOGVIEW)
    list(APPEND moc_files LogLoadData.hpp)
endif()


#if(ECFLOW_LOGVIEW)
#    list(APPEND moc_files LogLoadWidget.hpp)
#endif()

#set(wrap_ui_files
#    LogLoadWidget.ui
#    )

#if(ECFLOW_LOGVIEW)
#    set(wrap_ui_files
#        LogLoadWidget.ui
#        )
#endif()

if(ECFLOW_QT6)
  QT6_WRAP_CPP(LIBVIEWER_MOC ${moc_files} )
  QT6_WRAP_UI       (LIBVIEWER_FORMS_HEADERS ${wrap_ui_files})
elseif(ECFLOW_QT5)
  QT5_WRAP_CPP(LIBVIEWER_MOC ${moc_files} )
  QT5_WRAP_UI       (LIBVIEWER_FORMS_HEADERS ${wrap_ui_files})
endif()

# add all the images as dependencies of the resource file so that it is
# automatically recompiled when an image changes
#file( GLOB image_files "${CMAKE_CURRENT_SOURCE_DIR}/../images/*.*" )
#ADD_CUSTOM_TARGET(Qt_resource_cpp DEPENDS ${VIEWER_RES})
#ADD_DEPENDENCIES(Qt_resource_cpp ${image_files})

add_definitions( -DECFLOW_SHARED_DIR="${CMAKE_INSTALL_PREFIX}/share/ecflow" )

ecbuild_add_library( TARGET viewer
                     NOINSTALL
                     TYPE     STATIC
                     SOURCES  ${srcs} ${LIBVIEWER_MOC} ${LIBVIEWER_RES} ${LIBVIEWER_FORMS_HEADERS}
                    )
target_include_directories( viewer PRIVATE  .
                                            ../../../ACore/src
                                            ${Boost_INCLUDE_DIRS}
                                            ${CMAKE_CURRENT_BINARY_DIR}
)

=== share/ecflow/etc/CMakeLists.txt ===

# the list of files we want to install
set (files ecflowview_menus.json 
           ecflowview_attribute_conf.json
           ecflowview_gui.json 
           ecflowview_gui_server.json
           ecflowview_highlighter.json
           ecflowview_icon_conf.json
           ecflowview_menu_conf.json
           ecflowview_network_conf.json
           ecflowview_notification_conf.json
           ecflowview_nstate_conf.json
           ecflowview_palette.json
           ecflowview_panels.json
           ecflowview_panel_conf.json
           ecflowview_query_conf.json
           ecflowview_sstate_conf.json
           ecflowview_server_conf.json
           ecflowview_view_conf.json
           ecflow_ui_test.def
           ecflow_ui_test_session_template.json
           ecflow_ui_test_server_scripts.tar.gz
           shortcuts.txt
           viewer.qss)

# for each file, copy it into the build directory at build time
# and install it into the installation directory at install time (!)
foreach( f ${files} )
    configure_file(${f} ${CMAKE_CURRENT_BINARY_DIR} COPYONLY)
    
    install( FILES ${CMAKE_CURRENT_BINARY_DIR}/${f}  
             DESTINATION share/ecflow/etc
             PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ)
endforeach()

=== debian/changelog ===
ecflow (5.9.2-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 07 Dec 2022 11:14:03 +0000

ecflow (5.9.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 10 Nov 2022 12:22:55 +0000

ecflow (5.9.0-1) unstable; urgency=medium

  * New upstream release
  * gcc++-12 patch now merged upstream
  * Drop unused soname.patch
  * Switch Qt5 -> Qt6. Drop Qt5 dependencies and instead use
    qt6-base-dev, libqt6core5compat6-dev, libqt6svg6-dev, qt6-charts-dev,
    libqt6opengl6-dev, libxkbcommon-dev
  * Standards-Version: 4.6.1
  * B-D on doxygen

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 12 Oct 2022 09:29:27 +0100

=== debian/control ===
Source: ecflow
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-buildinfo,
  dh-sequence-python3, 
  python3-all-dev,
  ecbuild (>= 3.3.0-3),
  doxygen,
  chrpath, 
  libmotif-dev, 
  libxpm-dev,
  libssl-dev,
  qt6-base-dev,
  libqt6core5compat6-dev,
  libqt6svg6-dev,
  qt6-charts-dev,
  libqt6opengl6-dev,
  libxkbcommon-dev,
  libboost-test-dev, 
  libboost-serialization-dev,
  libboost-date-time-dev, 
  libboost-timer-dev,
  libboost-chrono-dev,
  libboost-thread-dev,
  libboost-regex-dev, 
  libboost-python-dev (>= 1.71.0-7+b1), 
  libboost-program-options-dev, libboost-filesystem-dev
Standards-Version: 4.6.1
Homepage: https://software.ecmwf.int/wiki/display/ECFLOW/The+ECFLOW+Pre-processor
Vcs-Browser: https://salsa.debian.org:/science-team/ecflow.git
Vcs-Git: https://salsa.debian.org:/science-team/ecflow.git -b debian/latest


Package: ecflow-server
Architecture: any
Depends: ${python3:Depends}, ${shlibs:Depends}, ${misc:Depends}, ksh | mksh | pdksh | zsh
Description: Meteorological workflow controller - server 
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.


Package: ecflow-client
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends},
 ${python3:Depends}, python3,  python3-fuse
Description: Client tools for Meteorological workflow
 ecFlow is a work flow package that enables users to run
 a large number of programs ( with dependencies on each other
 and on time) in a controlled environment.
 It provides reasonable tolerance for hardware and software failures,
 combined with good restart capabilities.
 .
 ecFlow submits tasks(jobs) and receives acknowledgements from tasks
 when they change status and when they send events, using child commands
 embedded in the scripts. ecflow stores the relationship between tasks,
 and is able to submit tasks dependent on triggers.
 .
 This package contains the client tools

Package: python3-ecflow
Section: python
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, python3-fuse
Description: Python3 libraries for ecFlow workflow tools
 ecFlow is a meteorological work flow package that enables
 users to run a large number of programs ( with dependencies
 on each other and on time) in a controlled environment.
 .
 This package contains Python3 modules used in writing ecflow scripts.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

# The magic debhelper  rule
%:
	dh $@  --with-buildsystem=ecbuild


DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
TARGET_ARCH ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_CPU)

# Needed by dh_python
export DEB_HOST_ARCH = $(shell dpkg-architecture -qDEB_HOST_ARCH)

PY3VERSIONS:=$(shell py3versions -r)

FPIC_ARCH:= hppa x32 i386
FPIC:=  $(if $(filter $(DEB_TARGET_ARCH), $(FPIC_ARCH)),  -fPIC,  )

CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(FPIC) $(CPPFLAGS)  -DNO_REGEXP
LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS) $(FPIC)
CXXFLAGS:= $(shell dpkg-buildflags --get CXXFLAGS) $(FPIC) # -std=c++11

CMAKE_COMMON_FLAGS = \
		-DBOOST_INCLUDEDIR=/usr/include \
		-DBoost_DATE_TIME_LIBRARY_RELEASE=$(LIBDIR)/libboost_date_time.so  \
		-DBoost_TIMER_LIBRARY_RELEASE=$(LIBDIR)/libboost_timer.so \
		-DBoost_CHRONO_LIBRARY_RELEASE=$(LIBDIR)/libboost_chrono.so \
		-DBoost_UNIT_TEST_FRAMEWORK_LIBRARY_RELEASE=$(LIBDIR)/libboost_unit_test_framework.so \
		-DBoost_FILESYSTEM_LIBRARY_RELEASE=$(LIBDIR)/libboost_filesystem.so  \
		-DBoost_PROGRAM_OPTIONS_LIBRARY_RELEASE=$(LIBDIR)/libboost_program_options.so  \
		-DBoost_REGEX_LIBRARY_RELEASE=$(LIBDIR)/libboost_regex.so  \
		-DBoost_SERIALIZATION_LIBRARY_RELEASE=$(LIBDIR)/libboost_serialization.so  \
		-DBoost_SYSTEM_LIBRARY_RELEASE=$(LIBDIR)/libboost_system.so \
		-DBoost_THREAD_LIBRARY_RELEASE=$(LIBDIR)/libboost_thread.so  \
		-DBOOSTROOT=$(LIBDIR)	\
		-DENABLE_STATIC_BOOST_LIBS=OFF \
		-DENABLE_SSL=ON \
		-DCMAKE_C_CFLAGS="${CFLAGS} ${LDFLAGS}"  

override_dh_auto_clean:
	dh_auto_clean
	find . -name '*.pyc' -delete
	find . -name '*.job*' -delete

# For the moment set ENABLE_SSL=OFF. Enabling it fails tests

override_dh_auto_configure:
	for p in ${PY3VERSIONS} ; do \
		set -e; \
		PY3AB=`echo $$p | sed -e 's/python3\./python3/' `  ; \
		PY3VER=`echo $$p | sed -e 's/python//' `; \
		PY3UPPER=`echo $${PY3AB} | tr '[:lower:]' '[:upper:]' `  ; \
		dh_auto_configure --builddirectory=debian/build-$$p -- \
			${CMAKE_COMMON_FLAGS} \
			-DPython3_EXECUTABLE=/usr/bin/$$p \
			-DBoost_$${PY3UPPER}_LIBRARY_RELEASE=$(LIBDIR)/libboost_$${PY3AB}.so  ; \
		done

override_dh_auto_build:
	for p in ${PY3VERSIONS} ; do \
		set -e; \
		dh_auto_build  --builddirectory=debian/build-$$p ; done

override_dh_auto_install:
	for p in ${PY3VERSIONS} ; do \
		set -e; \
		dh_auto_install --builddirectory=debian/build-$$p ; \
		done
	#	Drop the suffixes on scripts ...
	mv $(DESTDIR)/usr/bin/ecflow_logserver.sh $(DESTDIR)/usr/bin/ecflow_logserver
	mv $(DESTDIR)/usr/bin/ecflow_start.sh 	$(DESTDIR)/usr/bin/ecflow_start
	mv $(DESTDIR)/usr/bin/ecflow_stop.sh 	$(DESTDIR)/usr/bin/ecflow_stop
	mv $(DESTDIR)/usr/bin/ecflow_fuse.py 	$(DESTDIR)/usr/bin/ecflow_fuse
	mv $(DESTDIR)/usr/bin/ecflow_logsvr.pl	$(DESTDIR)/usr/bin/ecflow_logsvr
